/*--------------------------------------------------------------*/
/* ACM ICPC 2009-2010, NEERC                                    */
/* Northern Subregional Contest                                 */
/* St Petersburg, October 17, 2009                              */
/*--------------------------------------------------------------*/
/* Problem D. Dragon's Question                                 */
/*                                                              */
/* Original idea         Georgiy Korneev                        */
/* Problem statement     Dmitry Shtukenberg                     */
/* Testset               Georgiy Korneev                        */
/*--------------------------------------------------------------*/
/* Solution                                                     */
/*                                                              */
/* Author                Andrew Stankevich                      */
/*--------------------------------------------------------------*/
 
import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.math.BigInteger;
import java.util.Scanner;

class dragon_as implements Runnable {
    public void solve() throws IOException {
        Scanner in = new Scanner(new File("dragon.in"));
        PrintWriter out = new PrintWriter(new File("dragon.out"));

        int n = in.nextInt();
        int d = in.nextInt();

        BigInteger l = BigInteger.valueOf(10).pow(n - 1);
        BigInteger a = BigInteger.valueOf(10).pow(n).subtract(BigInteger.ONE).divide(BigInteger.valueOf(d)).multiply(BigInteger.valueOf(d));
        if (a.compareTo(l) < 0) {
            out.println("No solution");
        } else {
            out.println(a);
        }

        in.close();
        out.close();
    }

    public void run() {
        try {
            solve();
        } catch (IOException e) {
            e.printStackTrace();
            throw new AssertionError();
        }
    }

    public static void main(String[] args) {
        new Thread(new dragon_as()).start();
    }
}